function [battANALOG,ATTIVA,FIG] = report_3DCrL_ENG(r3DCrL,m,Nodo3DCrackLink,toolrif,...
    unitrif,contunit,datarif,Font_caption,Font_tools,battANALOG,ATTIVA,siteID,DT,...
    FIG,br,status,conn,FileName)

import mlreportgen.dom.*
import mlreportgen.report.*

% Make sure DOM is compilable
makeDOMCompilable()

if status(m,1) == 1
    if ATTIVA == 1
        ATTIVA = 0;
        testo = Paragraph('GMUX not installed or inactive.');
        add(DT,testo);
    end
elseif status(m,1) == 3
    if ATTIVA == 1
        ATTIVA = 0;
        testo = Paragraph(['Monitoring completed. Please log into the web-based platoform '...
            'to access the complete dataset.']);
        add(DT,testo);
    end
else
    Cr3D = Section();
    sez3DCrack = Heading3('3D Crack Link');
    sez3DCrack.Style = {OuterMargin('0in','0in','0.15in','0in'),FontSize(Font_tools),Bold(1),Italic(1)};
    Cr3D.Title = sez3DCrack;
    if battANALOG == 0
        comando = ['select Date, Time, UnitName, ToolNameID, BatLevel, Temperature from RawDataView where Date >= ''' ...
            datarif ''' and UnitName = ''' char(unitrif) ''' and ToolNameID = '''...
            char(toolrif) ''' and NodeNum = 1 '];
        curs = exec(conn,comando);
        curs = fetch(curs);
        BatTemp = curs.Data;
        [~,cc] = size(BatTemp);
        if cc ~= 1 %ci sono dati riferiti all'ultimo mese/periodo di interesse
            DataPlot = [BatTemp(:,1) BatTemp(:,2)];
            % sistemo date, batteria e temperatura
            [rD,~] = size(DataPlot);
            T = [cell2mat(DataPlot(:,1)) repmat(' ', [rD,1]) cell2mat(DataPlot(:,2))];
            Date = datenum(T);
            Batteria = cell2mat(BatTemp(:,5));
            Temperatura = cell2mat(BatTemp(:,6));
            
            % testo introduttivo
            testoB1 = Paragraph(['The following chart reports the battery level trend recorded during the reference time period. '...
                'The correct functioning of the GMUX module is guaranteed for a minimum level of 12 V. The last '...
                'available data is equal to ' num2str(Batteria(end,1)) ' V.']);
            testoB2 = Paragraph(['The GMUX module equips also a thermometer that allows the monitoring of the working '...
                'temperature and the identification of eventual malfunctioning. The following chart reports temperature '...
                'data recorded by the GMUX module.']);
            testoB1.HAlign = 'justify';
            testoB2.HAlign = 'justify';
            
            % grafico batteria
            figure(19)
            plot(Date,Batteria);
            hold on
            title('Battery level and GMUX temperature');
            xlabel('Date [dd/mm/yyyy]');
            ylabel('Level [V]');
            ylim([floor(min(Batteria(:,1))) ceil(max(Batteria(:,1)))]);
            
            yyaxis right
            GMUX = plot(Date,Temperatura,':','LineWidth',1.1);
            ylim([floor(min(Temperatura(:,1))) ceil(max(Temperatura(:,1)))]);
            ylabel(['Temperature [' char(176) 'C]']);
            set(gca,'YColor','k');
            str(1,1) = cellstr('Battery');
            str(2,1) = cellstr('Temperature');
            legend(str,'Location','northwest');
            h = gca;
            h.XAxis.MinorTick = 'on';
            datetick('x','dd/mm/yyyy','keepticks','keeplimits');
            xtickangle(20);
            grid on
            grid minor
            xlim([Date(1)-1 Date(end)+1]);
            
            TempName = char(strcat('Report',siteID,'-', contunit,'-GMUX_ENG.png'));
            saveas(GMUX,TempName);
            ChartGMUX = Image(TempName);
            ChartGMUX.Style = {Height('8cm'),HAlign('center')};
            
            if Batteria(end,1) >= 13
                TempName = char(strcat('B_13.jpg'));
            elseif Batteria(end,1) >= 12
                TempName = char(strcat('B_12.jpg'));
            elseif Batteria(end,1) >= 11
                TempName = char(strcat('B_11.jpg'));
            else
                TempName = char(strcat('B_10.jpg'));
            end
            Batt = Image(TempName);
            Batt.Style = {Height('4cm'),HAlign('center')};
            
            lot = Table({ChartGMUX, Batt});
            lot.TableEntriesStyle = {HAlign('center'),VAlign('middle')};
            lot.Style = {ResizeToFitContents(false),Width("100%")};
            grps(1) = TableColSpecGroup;
            grps(1).Span = 2;
            specs(1) = TableColSpec;
            specs(1).Span = 1;
            specs(1).Style = {Width("80%")};
            specs(2) = TableColSpec;
            specs(2).Span = 1;
            specs(2).Style = {Width("20%")};
            grps(1).ColSpecs = specs;
            lot.ColSpecGroups = grps;
            
            lot_cap = Paragraph(['Fig. ' num2str(FIG) ' - Battery level and GMUX temperature recorded '...
                'during the reference time period']);
            FIG = FIG+1;
            lot_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            Batt = Section();
            sezBATT = Heading3('GMUX - Battery level and temperature');
            sezBATT.Style = {FontSize(Font_tools),Bold(1),Italic(1)};
            Batt.Title = sezBATT;
            add(DT,sezBATT);
            add(DT,testoB1);
            add(DT,testoB2);
            add(DT,lot);
            add(DT,lot_cap);
            add(DT,br);
            close(figure(19));
            battANALOG = 1;
        end
    end
    add(DT,sez3DCrack);
    for cr = 1:r3DCrL(m,1)
        NodeNum = num2str(Nodo3DCrackLink(cr,m));
        comando = ['select EventDate, EventTime, XShift, YShift, ZShift from ElabDataView where EventDate >= ''' ...
            datarif ''' and  ToolNameID = ''' char(toolrif) ''' and UnitName = ''' char(unitrif) ...
            ''' and NodeNum = ''' NodeNum ''' '];
        curs = exec(conn,comando);
        curs = fetch(curs);
        Dati = curs.Data;
        % Modifico il formato di data e ora
        [rD,rC] = size(Dati);
        if rC ~= 1
            T = [cell2mat(Dati(:,1)) repmat(' ', [rD,1]) cell2mat(Dati(:,2))];
            Date = datenum(T); % Data
            X = cell2mat(Dati(:,3)); % Fessura
            Y = cell2mat(Dati(:,4)); % Fessura
            Z = cell2mat(Dati(:,5)); % Fessura
            sX = X-X(1);
            sY = Y-Y(1);
            sZ = Z-Z(1);
            
            % grafico pressione atmosferica NELL'ULTIMO MESE
            figure(5);
            plot(Date,sX);
            hold on
            plot(Date,sY);
            apertura = plot(Date,sZ);
            title(['Opening/closing of the crack meter - node number ' NodeNum]);
            xlabel('Date [dd/mm/yyyy]');
            ylabel('Deformation [mm]');
            controlX = abs(max(sX)-min(sX));
            controlY = abs(max(sY)-min(sY));
            controlZ = abs(max(sZ)-min(sZ));
            controlXYZ = [controlX; controlY; controlZ];
            control = max(controlXYZ);
            if control < 0.5 % mm
                ylim([-0.5 0.5]);
            end
            xlim([Date(1)-1 Date(end)+1]);
            h = gca;
            h.XAxis.MinorTick = 'on';
            datetick('x','dd/mm/yyyy','keepticks','keeplimits');
            xtickangle(15);
            grid on
            grid minor
            hold off
            str(1,1) = cellstr('X');
            str(2,1) = cellstr('Y');
            str(3,1) = cellstr('Z');
            MX(1) = max(sX(1:10));
            MX(2) = max(sY(1:10));
            MX(3) = max(sZ(1:10));
            MN(1) = min(sX(1:10));
            MN(2) = min(sY(1:10));
            MN(3) = min(sZ(1:10));
            VAR(1) = max(MX);
            VAR(2) = min(MN);
            MAX = max(abs(VAR));
            IN = find(abs(VAR)==MAX);
            if IN == 1 % Legenda sotto
                legend(str,'Location','southwest');
            else
                legend(str,'Location','northwest');
            end
            
            TempName = char(strcat('Report',siteID,'-', char(toolrif),'-3DCrack', NodeNum, '_ENG.png'));
            saveas(apertura,TempName);
            Chart3DCrL = Image(TempName);
            Chart3DCrL.Style = {Height('7.5cm'),HAlign('center')};
            Chart3DCrL_cap = Paragraph(['Fig. ' num2str(FIG) ' - Opening (increasing trend) and closing (decreasing trend) '...
                'over time, recorded along instrumental axes by the crack meter, node number ' NodeNum ...
                ', during the reference time period']);
            FIG = FIG+1;
            Chart3DCrL_cap.Style = {HAlign('justify'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            
            testo = Paragraph(['Following graphs report differential deformation data recorded along the three instrumental axes '...
                'by 3D crack meters composing the Analog Array.']);
            testo2 = Paragraph(['During the reference time period, node number ' NodeNum ...
                'recorded absolute opening values reported below: ']);
            testoX = Paragraph(['- X axis - Maximum absolute value: ' num2str(round(max(X),2), '%0.2f') ...
                ' mm, minimum value: ' num2str(round(min(X),2), '%0.2f') ' mm, variation: ' ...
                num2str(round(max(X),2)-round(min(X),2),'%0.2f') ' mm; ']);
            testoY = Paragraph(['- Y axis - Maximum absolute value: ' num2str(round(max(Y),2), '%0.2f') ...
                ' mm, valore minimo: ' num2str(round(min(Y),2), '%0.2f') ' mm, variation: ' ...
                num2str(round(max(Y),2)-round(min(Y),2),'%0.2f') ' mm; ']);
            testoZ = Paragraph(['- Z axis - Maximum absolute value: ' num2str(round(max(Z),2), '%0.2f') ...
                ' mm, minimum value: ' num2str(round(min(Z),2), '%0.2f') ' mm, variation: ' ...
                num2str(round(max(Z),2)-round(min(Z),2),'%0.2f') ' mm. ']);
            spazio = Paragraph('');
            
            testo.HAlign = 'justify';
            testo2.HAlign = 'justify';
            if cr == 1
                add(DT,testo);
            end
            add(DT,testo2);
            add(DT,testoX);
            add(DT,testoY);
            add(DT,testoZ);
            add(DT,Chart3DCrL);
            add(DT,Chart3DCrL_cap);
            add(DT,spazio);
            if cr == r3DCrL(m,1)
                add(DT,br);
            end
            close(figure(19));
            close(figure(5));
        else
            if ATTIVA == 1
                ATTIVA = 0;
                CrE = Section();
                sez3DCrack = Heading3('3D Crack Link');
                sez3DCrack.Style = {OuterMargin('0in','0in','0.15in','0in'),FontSize(Font_tools),Bold(1),Italic(1)};
                CrE.Title = sez3DCrack;
                add(DT,sez3DCrack);
                testo = Paragraph('c');
                add(DT,testo);
                add(DT,br);
            end
        end
    end
end

fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'report_3DCrL_ENG function executed correctly';
fprintf(fileID,fmt,text);
fclose(fileID);

end